// CBitmap.cpp : XbhǗ
//

#include "dxstdafx.h"
#include <process.h>
#include "CThread.h"

namespace MySystem{

// ---------------------------------------------------------------------------
// Xbh
// ---------------------------------------------------------------------------
CThreadMgr::CThreadMgr(unsigned ( __stdcall *func )( void * )
				, int thread_max  // őXbhiCPU̐Ɠxj
				, int work_max )  // Xbhɗ߂d̐
{
	unsigned int  dummy;

	m_ThreadMax = thread_max;
	m_WorkMax   = work_max;
	
	m_hThread = new HANDLE[thread_max];
	m_pThread = new CThreadData[work_max];
	m_bThreadEnable = TRUE;

	for( int i = 0; i < thread_max; i++ )
	{
		m_hThread[i] = (HANDLE)_beginthreadex( NULL, 0, func, this, 0, &dummy );
	}
}

// ---------------------------------------------------------------------------
// XbhI
// ---------------------------------------------------------------------------
CThreadMgr::~CThreadMgr()
{
	m_bThreadEnable = FALSE;

	for( int i = 0; i < m_ThreadMax; i++ )
	{
		WaitForSingleObject( m_hThread[i], INFINITE );  // MXbhI҂
		CloseHandle( m_hThread[i] );                    // nh
	}

	delete[] m_pThread;
	delete[] m_hThread;
}


// ---------------------------------------------------------------------------
// XbhɃf[^̃NGXg
// ---------------------------------------------------------------------------
int CThreadMgr::Req( void *pData )
{
	for( int i = 0; i < m_WorkMax; i++ )
	{
		if( THREAD_DEAD == m_pThread[i].GetState() )
		{
			m_pThread[i].SetData( pData );
			m_pThread[i].SetState( THREAD_WAIT );
			return 0;
		}
	}

	return -1;
}


// ---------------------------------------------------------------------------
// ܂dcĂH
// ---------------------------------------------------------------------------
int CThreadMgr::GetLeftWork()
{
	int count = 0;

	for( int i = 0; i < m_WorkMax; i++ )
	{
		if( THREAD_DEAD != m_pThread[i].GetState() ) count++;
	}

	return count;
}


// ---------------------------------------------------------------------------
// dƂĂ
// ---------------------------------------------------------------------------
CThreadData *CThreadMgr::GetWork()
{
	for( int i = 0; i < m_WorkMax; i++ )
	{
		if(THREAD_WAIT == m_pThread[i].GetState())
		{
			m_pThread[i].SetState( THREAD_RUN );
			return &m_pThread[i];
		}
	}

	return NULL;
}
}//namespace MySystem;
