#ifndef __CTHREAD_H_
#define __CTHREAD_H_

#include "dxstdafx.h"

namespace MySystem{
// ---------------------------------------------------------------------------
// Xbh
// ---------------------------------------------------------------------------

// f[^̏
typedef enum
{
	THREAD_DEAD=0,
	THREAD_WAIT,
	THREAD_RUN,
}THREAD_STATE;

// ---------------------------------------------------------------------------
// Xbh̃f[^NX
// ---------------------------------------------------------------------------
class CThreadData
{
private:
	void         *m_pData;
	THREAD_STATE  m_iState;
public:
	CThreadData() : m_iState(THREAD_DEAD), m_pData(NULL){}

	THREAD_STATE GetState() const {return m_iState;}
	void SetState( THREAD_STATE s ) {m_iState = s;}
	void Finish() {SetState(THREAD_DEAD);}  // I܂

	void *GetData() const {return m_pData;}
	void SetData( void *p ) {m_pData = p;}
};

// ---------------------------------------------------------------------------
// Xbh̊ǗNX
// ---------------------------------------------------------------------------
class CThreadMgr
{
private:
	enum
	{
		THREAD_MAX = 2,           // őXbhiCPU̐Ɠxj
		THREAD_WORK_MAX = 16,     // Xbhɗ߂d̐
	};

	HANDLE      *m_hThread;       // Xbh̃nh
	CThreadData *m_pThread;       // Xbh̃f[^
	bool         m_bThreadEnable; // Iǂ
	int          m_ThreadMax;
	int          m_WorkMax;

public:
	 CThreadMgr( unsigned ( __stdcall *func )( void * )
				, int thread_max  // őXbhiCPU̐Ɠxj
				, int work_max ); // Xbhɗ߂d̐
	 ~CThreadMgr();

	// sNGXg
	int Req( void *pData );       // XbhɎd̃NGXg
	int GetLeftWork();               // ܂dcĂH

	// Ăяo֐ł֐
	CThreadData *GetWork();       // dƂĂ
	bool IsEnable() const {return m_bThreadEnable;}
};
}//namespace MySystem;

#endif // !__CTHREAD_H_

